/*̧قDoxygenpɏĂ܂B*/
//! \file *********************************************************************
//!
//! \brief USBνė(ڑF)ͯ ̧
//!
//! ̧ق͕W(ڑF)菇ɑΉUSB߲0Ǘٰ݂܂݂܂(USBd
//! l̑9͂Q)B
//!
//! - ߲		: AVRpIAR EWAVRGNU GCC
//! - x޲	: AT90USB1287, AT90USB1286, AT90USB647, AT90USB646
//!
//! \author	Atmel Corporation	: http://www.atmel.com \n
//!			xFAQ			: http://support.atmel.no/
//!
//! ***************************************************************************

/* 쌠 (c) 2007, Atmel Corporation S\ς݁B
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. ATMEL̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * ATMELɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂATMEL̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂATMELɐӔC
 * Ȃł傤B
 */

#ifndef _USB_HOST_ENUM_H_
#define _USB_HOST_ENUM_H_

/*_____ ݸٰ _____________________________________________________________*/

#include "modules/usb/usb_task.h"

/*_____ ϸ _________________________________________________________________*/

#ifndef SIZEOF_DATA_STAGE
  #error SIZEOF_DATA_STAGE should be defined in conf_usb.h
#endif

#if (SIZEOF_DATA_STAGE<0xFF)				//! data_stage[]eʂɏ]ċLqqψʎwWœK
  #define T_DESC_OFFSET		U8				//! U8͏[荂
#else
  #define T_DESC_OFFSET		U16				//! U16KvƂ!
#endif

#ifndef MAX_EP_PER_INTERFACE
  #define MAX_EP_PER_INTERFACE 4
#endif

/*_____ W` ____________________________________________________________*/

//! @defgroup host_enum USBνė(ڑF)֐
//! @{

//! USB\ݒ(SETUP)ް
typedef struct
{
	U8  bmRequestType;						//!< v̓
	U8  bRequest;							//!< wv
	U16 wValue;								//!< vɏ]ĕς̈
	U16 wIndex;								//!< vɏ]ĕς̈
	U16 wLength;							//!< ްȂΓ]޲Đ
	U8  uncomplete_read;					//!< 1=1ǂݍ݂̂
} S_usb_setup_data;

typedef struct
{
	U8  ep_addr;
	U8  pipe_number;
	U8  ep_size;
	U8  ep_type;
} S_usb_endpoint;

typedef struct
{
	U8  interface_nb;
	U8  altset_nb;
	U16 class;
	U16 subclass;
	U16 protocol;
	U8  nb_ep;
	S_usb_endpoint ep[MAX_EP_PER_INTERFACE];
} S_usb_interface;

typedef struct
{
	U8  device_address;
	U8  ep_ctrl_size;
	U8  hub_port_nb;
	U8  parent_hub_number;
	U8  nb_interface;
	U16 pid;
	U16 vid;
	U8  bmattributes;
	U8  maxpower;
	S_usb_interface interface[MAX_INTERFACE_FOR_DEVICE];
} S_usb_device;

typedef struct
{
	U8  nb_device;
	S_usb_device device[MAX_DEVICE_IN_USB_TREE];
} S_usb_tree;

#if (USB_HUB_SUPPORT==ENABLE)
extern U8 user_periodic_pipe;
#endif
extern S_usb_tree usb_tree;
extern S_usb_setup_data usb_request;
extern U8 data_stage[SIZEOF_DATA_STAGE];
extern U8 device_status;

#define REQUEST_TYPE_POS				0
#define REQUEST_POS						1
#define VALUE_HIGH_POS					2
#define VALUE_LOW_POS					3
#define INDEX_HIGH_POS					4
#define INDEX_LOW_POS					5
#define LENGTH_HIGH_POS					6
#define LENGTH_LOW_POS					7
#define UNCOMPLETE_READ_POS				8
#define DATA_ADDR_HIGH_POS				9
#define DATA_ADDR_LOW_POS				10

#define CONTROL_GOOD					0
#define CONTROL_DATA_TOGGLE				0x01
#define CONTROL_DATA_PID				0x02
#define CONTROL_PID						0x04
#define CONTROL_TIMEOUT					0x08
#define CONTROL_CRC16					0x10
#define CONTROL_STALL					0x20
#define CONTROL_NO_DEVICE				0x40

//!< ްiKł̕ψʗp`̑g
#define OFFSET_FIELD_MAXPACKETSIZE		7
#define OFFSET_FIELD_MSB_VID			9
#define OFFSET_FIELD_LSB_VID			8
#define OFFSET_FIELD_MSB_PID			11
#define OFFSET_FIELD_LSB_PID			10

#define OFFSET_DESCRIPTOR_LENGHT		0
#define OFFSET_FIELD_DESCRIPTOR_TYPE	1
#define OFFSET_FIELD_TOTAL_LENGHT		2
#define OFFSET_FIELD_BMATTRIBUTES		7
#define OFFSET_FIELD_MAXPOWER			8

//! ̪Lqqpψ
#define OFFSET_FIELD_NB_INTERFACE		4
#define OFFSET_FIELD_CLASS				5
#define OFFSET_FIELD_SUB_CLASS			6
#define OFFSET_FIELD_PROTOCOL			7

#define OFFSET_FIELD_INTERFACE_NB		2
#define OFFSET_FIELD_ALT				3
#define OFFSET_FIELS_NB_OF_EP			4

#define OFFSET_FIELD_EP_ADDR			2
#define OFFSET_FIELD_EP_TYPE			3
#define OFFSET_FIELD_EP_SIZE			4
#define OFFSET_FIELD_EP_INTERVAL		6

#define HOST_FALSE						0
#define HOST_TRUE						1

U8 host_send_control (U8*);

/**
 * host_clear_endpoint_feature
 *
 * @brief ̊֐ʹ߲ĉv𑗂܂B
 *
 * @param	U8 ep	(ڕW߲Ĕԍ)
 *
 * @return	
 */
#define host_clear_endpoint_feature(ep)	(usb_request.bmRequestType = USB_SETUP_SET_STAND_ENDPOINT,\
										 usb_request.bRequest      = SETUP_CLEAR_FEATURE,\
										 usb_request.wValue        = FEATURE_ENDPOINT_HALT << 8,\
										 usb_request.wIndex        = ep,\
										 usb_request.wLength       = 0,\
										 usb_request.uncomplete_read = FALSE,\
										 host_send_control(data_stage))
/**
 * host_get_configuration
 *
 * @brief ̊֐͌`Ԑݒ擾v𑗂܂B
 *
 * @param	Ȃ
 *
 * @return	
 */
#define host_get_configuration()		(usb_request.bmRequestType = USB_SETUP_GET_STAND_DEVICE,\
										 usb_request.bRequest      = SETUP_GET_CONFIGURATION,\
										 usb_request.wValue        = 0,\
										 usb_request.wIndex        = 0,\
										 usb_request.wLength       = 1,\
										 usb_request.uncomplete_read = FALSE,\
										 host_send_control(data_stage))
/**
 * host_set_configuration
 *
 * @brief ̊֐͌`Ԑݒݒv𑗂܂B
 *
 * @param	U8	ɂ`Ԑݒԍ
 *
 * @return	
 */
#define host_set_configuration(cfg_nb)	(usb_request.bmRequestType = USB_SETUP_SET_STAND_DEVICE,\
										 usb_request.bRequest      = SETUP_SET_CONFIGURATION,\
										 usb_request.wValue        = cfg_nb,\
										 usb_request.wIndex        = 0,\
										 usb_request.wLength       = 0,\
										 usb_request.uncomplete_read = FALSE,\
										 host_send_control(data_stage))
/**
 * host_set_interface
 *
 * @brief ̊֐Ͳ̪ɑ΂ē̑֐ݒw肷邽߂ɲ̪ݒv𑗂܂B
 *
 * @param	U8	interface_nb (̪)
 *			U8	alt_setting (ɂ֐ݒ)
 *
 * @return	
 */
#define host_set_interface(interface_nb,alt_setting)	(usb_request.bmRequestType = USB_SETUP_SET_STAND_DEVICE,\
										 usb_request.bRequest      = USB_SETUP_SET_STAND_INTERFACE,\
										 usb_request.wValue        = alt_setting,\
										 usb_request.wIndex        = interface_nb,\
										 usb_request.wLength       = 0,\
										 usb_request.uncomplete_read = FALSE,\
										 host_send_control(data_stage))

/**
 * host_get_device_descriptor_uncomplete
 *
 * @brief ̊֐͑uLqq擾v𑗂܂B
 * 󂯎Lqq\data_stagezɊi[܂B
 * 󂯎Lqq߲͐ߒɐ܂B
 *
 * @param	Ȃ
 *
 * @return	
 */
#define host_get_device_descriptor_uncomplete()	(usb_request.bmRequestType = USB_SETUP_GET_STAND_DEVICE,\
										 usb_request.bRequest      = SETUP_GET_DESCRIPTOR,\
										 usb_request.wValue        = DESCRIPTOR_DEVICE << 8,\
										 usb_request.wIndex        = 0,\
										 usb_request.wLength       = 64,\
										 usb_request.uncomplete_read = TRUE,\
										 host_send_control(data_stage))

/**
 * host_get_device_descriptor
 *
 * @brief ̊֐͑uLqq擾v𑗂܂B
 * 󂯎Lqq\data_stagezɊi[܂B
 *
 * @param	Ȃ
 *
 * @return	
 */
#define host_get_device_descriptor()	(usb_request.bmRequestType = USB_SETUP_GET_STAND_DEVICE,\
		 								 usb_request.bRequest      = SETUP_GET_DESCRIPTOR,\
										 usb_request.wValue        = DESCRIPTOR_DEVICE << 8,\
										 usb_request.wIndex        = 0,\
										 usb_request.wLength       = 18,\
										 usb_request.uncomplete_read = FALSE,\
										 host_send_control(data_stage))
/**
 * host_get_configuration_descriptor
 *
 * @brief ̊֐͑u`Ԑݒ擾v𑗂܂B
 * 󂯎`ԐݒLqq\data_stagezɊi[܂B
 *
 * @param	Ȃ
 *
 * @return	
 */
#define host_get_configuration_descriptor()	(usb_request.bmRequestType = USB_SETUP_GET_STAND_DEVICE,\
										 usb_request.bRequest      = SETUP_GET_DESCRIPTOR,\
										 usb_request.wValue        = DESCRIPTOR_CONFIGURATION << 8,\
										 usb_request.wIndex        = 0,\
										 usb_request.wLength       = 255,\
										 usb_request.uncomplete_read = FALSE,\
										 host_send_control(data_stage))

#define host_get_descriptor_uncomplete()	(usb_request.bmRequestType = USB_SETUP_GET_STAND_DEVICE,\
										 usb_request.bRequest      = SETUP_GET_DESCRIPTOR,\
										 usb_request.wValue        = 0,\
										 usb_request.wIndex        = 0,\
										 usb_request.wLength       = 64,\
										 usb_request.uncomplete_read = FALSE,\
										 host_send_control(data_stage))
/**
 * host_set_address
 *
 * @brief ̊֐ͱڽݒv𑗂܂B
 *
 * @param	U8	ڽ(uɑꂽڽ)
 *
 * @return	
 */
#define host_set_address(addr)			(usb_request.bmRequestType = USB_SETUP_SET_STAND_DEVICE,\
										 usb_request.bRequest      = SETUP_SET_ADDRESS,\
										 usb_request.wValue        = (U16)addr,\
										 usb_request.wIndex        = 0,\
										 usb_request.wLength       = 0,\
										 usb_request.uncomplete_read = FALSE,\
										 host_send_control(data_stage))

/**
 * host_set_feature_remote_wakeup
 *
 * @brief ̊֐͏uuNݒ𑗂܂B
 *
 * @param	Ȃ
 *
 * @return	
 */
#define host_set_feature_remote_wakeup()	(usb_request.bmRequestType = USB_SETUP_SET_STAND_DEVICE,\
										 usb_request.bRequest      = SETUP_SET_FEATURE,\
										 usb_request.wValue        = 1,\
										 usb_request.wIndex        = 1,\
										 usb_request.wLength       = 0,\
										 usb_request.uncomplete_read = FALSE,\
										 host_send_control(data_stage))

/**
 * host_ms_get_max_lun
 *
 * @brief ̊֐͑eʋLwv"őLUN擾"𑗂܂B
 *
 * @param	Ȃ
 *
 * @return	
 */
#define host_ms_get_max_lun()			(usb_request.bmRequestType = USB_SETUP_GET_CLASS_INTER,\
										 usb_request.bRequest      = SETUP_MASS_STORAGE_GET_MAX_LUN,\
										 usb_request.wValue        = 0,\
										 usb_request.wIndex        = 0,\
										 usb_request.wLength       = 1,\
										 usb_request.uncomplete_read = FALSE,\
										 host_send_control(data_stage))

/**
 * Get_VID
 *
 * @brief ̊֐͐ڑꂽuVIDԂ܂B
 *
 * @param	Ȃ
 *
 * @return	U16	(VIDl)
 */
#define Get_VID()						(usb_tree.device[selected_device].vid)

/**
 * Get_PID
 *
 * @brief ̊֐͐ڑꂽuPIDԂ܂B
 *
 * @param	Ȃ
 *
 * @return	U16	(PIDl)
 */
#define Get_PID()						(usb_tree.device[selected_device].pid)

/**
 * Get_ep0_size
 *
 * @brief ̊֐͑Iuɑ΂鐧߲Ă̗eʂԂ܂B
 *
 * @param	Ȃ
 *
 * @return	U8	(߲0̗e)
 */
#define Get_ep0_size()					(usb_tree.device[selected_device].ep_ctrl_size)

/**
 * Get_maxpower
 *
 * @brief ̊֐͐ڑu̍őd(2mAP)Ԃ܂B
 *
 * @param	Ȃ
 *
 * @return	U8	(őd͒l)
 */
#define Get_maxpower()					(usb_tree.device[selected_device].maxpower)

/**
 * @brief ̊֐͎w肵̪ƒgUSB׽Ԃ܂B
 *
 * @param	U8s_interface:	x̪ԍ
 *
 * @return	U16	(׽)
 */
#define Get_class(s_interface)			(usb_tree.device[selected_device].interface[s_interface].class)

/**
 * @brief ̊֐͎w肵̪ƒgUSB׽Ԃ܂B
 *
 * @param	U8	s_interface:	x̪ԍ
 *
 * @return	U16	(׽)
 */
#define Get_subclass(s_interface)		(usb_tree.device[selected_device].interface[s_interface].subclass)

/**
 * @brief ̊֐͎w肵̪ƒgUSBKԂ܂B
 *
 * @param	U8	s_interface:	x̪ԍ
 *
 * @return	U16	(K񕄍)
 */
#define Get_protocol(s_interface)		(usb_tree.device[selected_device].interface[s_interface].protocol)

/**
 * @brief ̊֐͎w肵̪Ƃ̲̪ł̴߲Ĕԍƒg߲ ڽԂ܂B
 *
 * @param	U8 s_interface:	x̪ԍ
 * @param	U8 n_ep:		̲̪ł̴߲Ĕԍ
 *
 * @return	U8	(߲ ڽ)
 */
#define Get_ep_addr(s_interface,n_ep)	(usb_tree.device[selected_device].interface[s_interface].ep[n_ep].ep_addr)

/**
 * @brief ̊֐͎x̪ƒg߲ĐԂ܂B
 *
 * @param	U8 s_interface:	x̪ԍ
 *
 * @return	U8 (߲Đ)
 */
#define Get_nb_ep(s_interface)			(usb_tree.device[selected_device].interface[s_interface].nb_ep)

/**
 * @brief ̊֐͎x̪ƒg֐ݒ̈搔Ԃ܂B
 *
 * @param	U8 s_interface:	x̪ԍ
 *
 * @return	U8 (֐ݒl)
 */
#define Get_alts_s(s_interface)			(usb_tree.device[selected_device].interface[s_interface].altset_nb)

/**
 * @brief ̊֐͎x̪ƒg̪ԍԂ܂B
 *
 * @param	U8 s_interface:	x̪ԍ
 *
 * @return	U8 (̪)
 */
#define Get_interface_number(s_interface)	(usb_tree.device[selected_device].interface[s_interface].interface_nb)

/**
 * @brief ̊֐͐ڑꂽuŎx̪Ԃ܂B
 *
 * @param	Ȃ
 *
 * @return	U8:	̪
 */
#define Get_nb_supported_interface()	(usb_tree.device[selected_device].nb_interface)

/**
 * @brief ̊֐͐ڑꂽuȋd̏ꍇTRUEԂ܂B
 *
 * @param	Ȃ
 *
 * @return	TRUE܂FALSE
 */
#define Is_device_self_powered()		((usb_tree.device[selected_device].bmattributes & USB_CONFIG_ATTRIBUTES_SELFPOWERED) ? TRUE : FALSE)

/**
 * @brief ̊֐USB؍\ŐڑꂽuԂ܂B
 *
 * @param	Ȃ
 *
 * @return	U8:	u
 */
#define Get_nb_device()					(usb_tree.nb_device)

/**
 * @brief ̊֐͑uuNxꍇTRUEԂ܂B
 *
 * @param	Ȃ
 *
 * @return	TRUE܂FALSE
 */
#define Is_device_supports_remote_wakeup()	((usb_tree.device[selected_device].bmattributes & USB_CONFIG_ATTRIBUTES_REMOTEWAKEUP) ? TRUE : FALSE)

#if (USB_HUB_SUPPORT==ENABLE && USER_PERIODIC_PIPE==ENABLE)
  #define Host_select_device(i)			(host_select_device(i))
#else
  #define Host_select_device(i)			(selected_device=i, Host_configure_address(usb_tree.device[i].device_address))
#endif

#define Host_get_nb_device()			((U16)(usb_tree.nb_device))

extern U8 selected_device;
extern U8 ctrl_pipe_size;

U8 host_check_VID_PID (void);
U8 host_check_class (void);
U8 host_auto_configure_endpoint();
T_DESC_OFFSET get_interface_descriptor_offset (U8 interface, U8 alt);
U8 host_get_hwd_pipe_nb (U8 ep_addr);
void init_usb_tree (void);
void remove_device_entry (U8 device_index);
void host_select_device (U8 i);

#if (USB_HUB_SUPPORT==ENABLE && USER_PERIODIC_PIPE==ENABLE)
void freeze_user_periodic_pipe (void);
void unfreeze_user_periodic_pipe (void);
#endif

//! @}

#endif // _USB_HOST_ENUM_H_
