/*̧قDoxygenpɏĂ܂B*/
//! \file *********************************************************************
//!
//! \brief ̧ق͒DataFlashٰ݂܂݂܂B
//!
//! - ߲		: AVRpIAR EWAVRGNU GCC
//! - x޲	: AT90USB1287, AT90USB1286, AT90USB647, AT90USB646
//!
//! \author	Atmel Corporation	: http://www.atmel.com \n
//!			xFAQ			: http://support.atmel.no/
//!
//! ***************************************************************************

/* 쌠 (c) 2007, Atmel Corporation S\ς݁B
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. ATMEL̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * ATMELɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂATMEL̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂATMELɐӔC
 * Ȃł傤B
 */

/*_____ ݸٰ _____________________________________________________________*/

#include "config.h"							// ь`Ԑݒ
#include "lib_mcu/usb/usb_drv.h"			// USBײޒ`
#include "lib_mcu/spi/spi_drv.h"			// SPIײޒ`
#include "df.h"								// DataFlash`

/*_____ ` ________________________________________________________________*/

static U32	gl_ptr_mem;						//  ް ߲
static U8	df_mem_busy;					// ZԂł
static U8	df_select;						// ݑIꂽ

/*_____ 錾 ________________________________________________________________*/

static void df_wait_busy (void);
static void df_chipselect_current (void);

//! ̊֐DataFlash䂳SPI޽܂B
//!
void df_init (void)
{
	// DataFlashDataFlashײފԂSPIʐM
	Df_init_spi();
	Spi_select_master();
	Spi_set_mode(SPI_MODE_3);
	Spi_init_bus();
	Spi_set_rate(SPI_RATE_0);				// SCKg=fosc/2
	Spi_disable_ss();
	Spi_enable();

	// DataFlash䕔
	df_mem_busy = 0;						// S؏
	df_select = 0;
}

//! ̊֐; ߲ɏ]DataFlashI܂B
//!
//! @verbatim
//! "df_select"ϐͱڽw肳ꂽ݂؂܂݂܂B
//! ǗɂĂ̂葽̏ɊւĂdf_translate_addr()֐̎QƂĂB
//! @endverbatim
//!
static void df_chipselect_memzone (U8 memzone)
{
#if (DF_NB_MEM == 1)
	df_select = 0;
#else
	#if (DF_NB_MEM == 2)
		#if (DF_PAGE_SIZE == 512)
	df_select = (memzone>>0)&0x01;
		#else
	df_select = (memzone>>1)&0x01;
		#endif
	#else
		#if (DF_PAGE_SIZE == 512)
	df_select = (memzone>>0)&0x03;
		#else
	df_select = (memzone>>1)&0x03;
		#endif
	#endif
#endif
}

//! ̊֐͌ݱڽw肳ꂽ؂𕨗IɑI܂B
//!
static void df_chipselect_current (void)
{
	Df_desel_all();
	switch (df_select)
	{
		case 0:
			Df_select_0();
			break;
#if (DF_NB_MEM > 1)
		case 1:
			Df_select_1();
			break;
#endif
#if (DF_NB_MEM > 2)
		case 2:
			Df_select_2();
			break;
		case 3:
			Df_select_3();
			break;
#endif
	}
}

//! ̊֐͘_ ڽ𕨗޲ ڽɕϊ܂(1_=512޲)B
//! ،`Ԑݒ(:1/2/4A߰:512޲/1024޲)̊֐ɉ
//!
//!   512޲Ă߰ނ :
//!   ========================
//!   "xx..xxba"ƂĘ_ ڽl@Ał'b''a'͍ŏI2ޯĂŁA"xx..xx"͍ŏʑޯĂ̖`lłB
//!      - 1؂gpꍇA̘_ ڽ͕IȾ ڽƒڈv܂B
//!        ̂ɕIȾ ڽ"xx..xxba"łB
//!      - 2؂gpꍇAޯ'a'͊֌WĂ؂Aڽ̎c͕Iȱڽ܂B
//!        ̂ɕIȾ ڽ"xx...xxb"łB
//!      - 4؂gpꍇAޯ'ba'͊֌WĂ؂Aڽ̎c͕Iȱڽ܂B
//!        ̂ɕIȾ ڽ"xx....xx"łB
//!
//!   1024޲Ă߰ނ :
//!   =========================
//!   "xx..xxcba"ƂĘ_ ڽl@Ał'c'A'b''a'͍ŏI3ޯĂŁA"xx..xx"͍ŏʑޯĂ̖`lłB
//!      - 1؂gpꍇA̘_ ڽ͕IȾ ڽƒڈv܂B
//!        ̂ɕIȾ ڽ"xx..xxcba"łB
//!      - 2؂gpꍇAޯ'b'͊֌WĂ؂Aڽ̎c͕Iȱڽ܂B
//!        ̂ɕIȾ ڽ"xx...xxca"łB
//!      - 4؂gpꍇAޯ'cb'͊֌WĂ؂Aڽ̎c͕Iȱڽ܂B
//!        ̂ɕIȾ ڽ"xx....xxa"łB
//!
//!
//! @param	log_sect_addr	_ ڽ
//!
//! @return	U32				 ڽ
//!
static U32 df_translate_addr (Uint32 log_sect_addr)
{
#if (DF_NB_MEM == 1)
	return (log_sect_addr << 9);			// 1؂̏ꍇ
#else
	#if (DF_NB_MEM == 2)
		#if (DF_PAGE_SIZE == 512)
	return ((log_sect_addr&0xFFFFFFFE) << 8);
		#else
	return (((log_sect_addr&0xFFFFFFFC) << 8) | ((log_sect_addr&0x00000001) << 9));
		#endif
	#else
		#if (DF_PAGE_SIZE == 512)
	return ((log_sect_addr&0xFFFFFFFC) << 7);
		#else
	return (((log_sect_addr&0xFFFFFFF8) << 7) | ((log_sect_addr&0x00000001) << 9));
		#endif
	#endif
#endif
}

//! ̊֐͑SĂDataFlash،s܂B
//!
//! @return	bit
//!	؂͏		 OK
//!	؂͌s	 KO
//!
Bool df_mem_check (void)
{
	// DataFlash،
	for(df_select=0; df_select<DF_NB_MEM; df_select++)
	{
		df_chipselect_current();
		Spi_write_data(DF_RD_STATUS);		// ڼ޽ǂݍݖߑo
											// + SPIF׸ނ邽߂̍ŏ̒iK
		Spi_write_data(0);					// U:
											// - SPIF׸ނ̉(SPDRւ̱)
											// - ڼ޽擾
											// - SPIF׸ނ邽߂̍ŏ̒iKs
		// ȉSpi_read_data()SPDR𱸾邱ƂɂSPIF׸ނ̉܂B
		// DataFlashx
		if ((Spi_read_data() & DF_MSK_DENSITY) != DF_DENSITY)
		{
			// \ʒl
			Df_desel_all();
			return (KO);
		}
		Df_desel_all();
	}
	return OK;
}

//! ̊֐DataFlashZłȂȂ܂ő҂܂B
//!
static void df_wait_busy (void)
{
	// DataFlashZłȂȂ܂ŏڼ޽ǂݍ
	df_chipselect_current();
	Spi_write_data(DF_RD_STATUS);			// ڼ޽ǂݍݖߑo
											// + SPIF׸ނ邽߂̍ŏ̒iK
	Spi_write_data(0);						// U:
											// - SPIF׸ނ̉(SPDRւ̱)
											// - ڼ޽擾
											// - SPIF׸މ̂߂̍ŏ̒iKs
	// ȉSpi_read_data()SPDRɂSPIF׸ނ̉܂B
	while ((Spi_read_data() & DF_MSK_BIT_BUSY) == DF_MEM_BUSY)
	{
		Spi_write_data(0);					// VԂ擾邽߂̋U
											// + SPIF׸މ̂߂̍ŏ̒iK
	}
	Df_desel_all();							// STATUSv̂܂܂ɂ邽߂ؑI
	Spi_ack_write();						// SPIF׸މ̂߂̍ŏIiK
}

//! ̊֐͗^ꂽ ڽǂݍݓDataFlashJ܂B
//!
//! : ڽ(DataFlash߰ޗeʂɈˑ)߰ނ̎n߂ɓȂ܂B
//!
//! @param	pos		_ ڽ
//!
//! @return	bit
//!	ĴOK
//!
Bool df_read_open (Uint32 pos)
{
	// ޲ ڽőS ߲ݒ
	gl_ptr_mem = df_translate_addr(pos);

	// "pos"DataFlashI("df_select"ϐXV܂B)
	df_chipselect_memzone(LSB0(pos));

	// DataFLashZȂAłȂȂ܂őҋ@
	if (is_df_busy(df_select))
	{
		df_release_busy(df_select);
		df_wait_busy();						// ۸ݸޏI҂
	}

	// IDataFlash𕨗IɊm(I)
	df_chipselect_current();

	//#
	//# ^ꂽ ڽ߰ޓǂݍ݂
	//#
	// ǂݍݎ喽ߑoA+ SPIF׸މ̍ŏ̒iK
	Spi_write_data(DF_RD_MAIN);
	// SPIF׸މ̍ŏIiK͎݂̏ōs܂B

	// ȉ\3̱ڽ ޲Ă𑗏o
	// - ߰ ڽ(n߂xޯ)
	// - ߰ޓ޲ ڽ(Iyޯ)
	// (xyDataFlash`Ɉˑ)
	// : 24ޯĂ𒴂gl_ptr_memޯĂDataFlash̋ǏڽwɗLł
	// ܂BDataFlash鎞ɂDataFlashʂɎgp
	// B
	Spi_write_data((MSB1(gl_ptr_mem) << DF_SHFT_B1) | (MSB2(gl_ptr_mem) >> DF_SHFT_B2));
	Spi_write_data(((MSB2(gl_ptr_mem) & ~DF_PAGE_MASK) << DF_SHFT_B1) | (MSB2(gl_ptr_mem) & DF_PAGE_MASK));
	Spi_write_data(MSB3(gl_ptr_mem));
	// SPIF׸މ̍ŏIiK͎݂̏ōs܂B

	// xēǂނ߂4̋U
	Spi_write_data(0xFF);
	Spi_write_data(0xFF);
	Spi_write_data(0xFF);
	Spi_write_data(0xFF);					// 0xFFMASPIF׸މ̍ŏ̒iK
	Spi_ack_write();						// SPIF׸މ̍Ō̒iK

	return OK;
}

//! ̊֐݂͌DataFlashI܂B
//!
void df_read_close (void)
{
	Df_desel_all();							// DataFlashI
}

//! ̊֐͍œKADataFlashUSBnb-sector~512޲Ă܂B
//!
//! :
//!   - ŏ̌Ăяodf_read_open()֐ĂяoɂĐsȂ΂Ȃ܂B
//!   - USB EPINɑIĂȂ΂Ȃ܂B
//!   - USB݊ɏՕ󂫂ŁA
//!   - 512߰ޗeʂ̖񐔂Ȃ̂ŁAe޲Ăɑ΂߰ޏI𒲂ׂKv܂B
//!   - v튄荞݂邽߁A荞݂͓]ɋ֎~܂B
//!   - nb_sector͏Ɂ1ŁA0ɂł܂B
//!
//! @param	nb_sector	ǂ[IN]A
//!
//! @return				ǂݍݐOK
//!
Bool df_read_sector (Uint16 nb_sector)
{
	U8 i;
#ifdef DF_CODE_SIZE_OPTIMIZATION
	U8 j;
#endif
	do
	{
		for (i = 8; i != 0; i--)
		{
			Disable_interrupt();			// S̊荞݋֎~

			// 				 : ޲Ă𓾂邽߂ɉ޲Ă𑗏o
			// Spi_write_data(0) : ޲Ă𑗏o+SPIF׸މ̍ŏ̒iK
			// Spi_read_data()	 : ޲Ď擾+SPIF׸މ̍Ō̒iK
#ifdef DF_CODE_SIZE_OPTIMIZATION
			for(j=0;j<64;j++)
			{
				Spi_write_data(0); Usb_write_byte(Spi_read_data());
			}
#else
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
#endif
			Usb_send_in();					// IN FOFOeUSBνĂ֑o

			Enable_interrupt();				// S̊荞ݍċ

			// IN FIFOɍĂя悤ɑMI܂őҋ@
			while(Is_usb_write_enabled()==FALSE)
			{
				if(!Is_usb_endpoint_enabled())
					return KO;				// USBؾ
			}
		}
		gl_ptr_mem += 512;					// S̱ڽ ߲is()
		nb_sector--;						// v팸
#if (DF_NB_MEM == 1)						// ߰ނ̍Ō?
	#if (DF_PAGE_SIZE == 512)
		Df_desel_all();
		if (nb_sector != 0)
			df_read_open(gl_ptr_mem>>9);
	#else
		if ((MSB2(gl_ptr_mem) & DF_PAGE_MASK) == 0x00)
		{
			Df_desel_all();
			if (nb_sector != 0)
				df_read_open(gl_ptr_mem>>9);
		}
	#endif
#endif
	}
	while (nb_sector != 0);

	return OK;
}

//! ̊֐͗^ꂽ ڽDataFlashݓŊJ܂B
//!
//! :߰ފɏՕ>512޲ĂȂAwrite_byte܂write64֐ɂĕIɍX
//! V邽߂ɁA߰ޓe͍ŏɊɏՕɐݒ肳܂B
//!
//! @param	pos	 ڽ
//!
//! @return		ĴOK
//!
Bool df_write_open (Uint32 pos)
{
	// ޲ ڽőS ߲ݒ
	gl_ptr_mem = df_translate_addr(pos);

	// "pos"dataFlashI
	df_chipselect_memzone(LSB0(pos));

	// DataFlashZȂAłȂȂ܂őҋ@
	if (is_df_busy(df_select))
	{
		df_release_busy(df_select);
		df_wait_busy();						// ۸ݸނ̏I҂
	}

#if DF_PAGE_SIZE > 512
	// IDataFlash𕨗IɊm(I)
	df_chipselect_current();

	//#
	//# ɏՕ1Ɍ݂߰ޓe]
	//#
	//  ߰ނɏՕ1֖߂𑗏oA+SPIF׸މ̍ŏ̒iK
	Spi_write_data(DF_TF_BUF_1);
	// SPIF׸މ̍Ō̒iK͎݂̏ōs܂B

	// ȉō\3̱ڽ ޲Ă𑗏o
	// - ߰ ڽ(n߂xޯ)
	// - ĉǂłǂޯ(yޯ)
	// (xyDataFlash`Ɉˑ)
	// :24ޯĂ𒴂gl_ptr_memޯĂDataFlash̋ǏڽwɗLł͂
	// ܂BDataFlashLƂɂDataFlashʂɎgp
	// B
	Spi_write_data((MSB1(gl_ptr_mem) << DF_SHFT_B1) | (MSB2(gl_ptr_mem) >> DF_SHFT_B2));
	Spi_write_data(MSB2(gl_ptr_mem) << DF_SHFT_B1);
	Spi_write_data(0);						// ĉǂłǂޯ
	Spi_ack_write();						// SPIF׸މ̍Ō̒iK

	Df_desel_all();							// ߂Lɂ邽߂ؑI

	df_wait_busy();							// ߰ޓ]Iҋ@
#endif

	// IDataFlash𕨗IɊm(I)
	df_chipselect_current();

	//#
	//# ^ꂽ ڽ߰ޏ݂
	//#
	// ɏՕ1ʂĎ ߰ޏݖ߂𑗏o
	// +SPIF׸މ̍ŏ̒iK
	Spi_write_data(DF_PG_BUF_1);
	// SPIF׸މ̍Ō̒iK͎݂̏ōs܂B

	// ȉō\3̱ڽ ޲Ă𑗏o
	// (.)߰ ڽ(n߂xޯ)
	// (.)߰ޓ޲ ڽ(yޯ)
	// (xyDataFlash`Ɉˑ)
	// :24ޯĂ𒴂gl_ptr_memޯĂDataFlashǏڽwɗLł͂
	// ܂BDataFlashL鎞ɂDataFlashʂɎgp܂B
	Spi_write_data((MSB1(gl_ptr_mem) << DF_SHFT_B1) | (MSB2(gl_ptr_mem) >> DF_SHFT_B2));
	Spi_write_data(((MSB2(gl_ptr_mem) & ~DF_PAGE_MASK) << DF_SHFT_B1) | (MSB2(gl_ptr_mem) & DF_PAGE_MASK));
	Spi_write_data(MSB3(gl_ptr_mem));
	Spi_ack_write();						// SPIF׸މ̍ŏIiK

   return OK;
}

//! ̊֐͘_(512޲)̍Ō𖞂߰ޏ݂Jn܂B
//!
void df_write_close (void)
{
	//#
	//# _(512޲)̍ŌɒBȂԁAc ޲Ă0Ŗ܂B
	//#
	while ((MSB3(gl_ptr_mem) != 0x00) || ((MSB2(gl_ptr_mem) & 0x01) != 0x00))
	{
		Spi_write_data(0x00);				// - SPIF׸މ̍ŏIiK
											// - 0x00
											// - SPIF׸މ̍ŏ̒iK
		gl_ptr_mem++;
	}
	Spi_ack_write();						// SPIF׸މ̍ŏIiK

	Df_desel_all();							// ߰ޏ݊Jn(܂whileJԂsȂꍇ͒PؑI)
	df_set_busy(df_select);					// ݂؂͑Z
}

//! ̊֐͍œKAUSB킩DataFlashnb-sector~512޲Ă܂B
//!
//! :
//!   - ŏ̌Ăяodf_write_open()֐ĂяoɂĐsȂ΂Ȃ܂B
//!   - 512߰ޗeʂ̖񐔂Ȃ̂ŁAe޲Ăɑ΂߰ޏI𒲂ׂKv܂B
//!   - USB OUT EP͐ɑIĂȂ΂Ȃ܂B
//!   - v튄荞݂邽߂ɁA]Ɋ荞݂͋֎~܂B
//!   - nb_sector͏Ɂ1ŁA0ɂł܂B
//!
//! @param	nb_sector	[IN]A
//!
//! @return				ݐOK
//!
Bool df_write_sector (Uint16 nb_sector)
{
	U8 i;
#ifdef DF_CODE_SIZE_OPTIMIZATION
	U8 j;
#endif
	do
	{
		//# USB OUT FIFO8~64=512޲ď
		for (i = 8; i != 0; i--)
		{
			// USB OUT EPŎMIҋ@
			while(!Is_usb_read_enabled())
			{
				if(!Is_usb_endpoint_enabled())
				return KO;					// USBؾ
			}

			Disable_interrupt();			// S̊荞݋֎~

			// SPI݌:޲đǒSPIF׸މ
			// Spi_write_data(Usb_read_byte()):(.) SPIF׸މ̍ŏIiK
			//								   (.) USBǂ޲Ă𑗏o
			//								   (.) SPIF׸މ̍ŏ̒iK
#ifdef DF_CODE_SIZE_OPTIMIZATION
			for(j=0;j<64;j++)
			{
				Spi_write_data(Usb_read_byte());
			}
#else
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
#endif
			Spi_ack_write();				// SPIF׸މ̍ŏIiK

			Usb_ack_receive_out();			// USB OUT EPǂݍ

			Enable_interrupt();				// S̊荞ݍċ
		} // for (i = 8; i != 0; i--)

		gl_ptr_mem += 512;					//  ߲XV
		nb_sector--;						// v팸

		//# ߰ނ̍ŌȂ߰ޏ݊Jn
		//#
#if DF_PAGE_SIZE > 512
		// 1024޲ ߰ނ̍Ōォ
		if ((MSB2(gl_ptr_mem) & DF_PAGE_MASK) == 0x00)
		{
			Df_desel_all();					// ߰ޏ݊Jn
			df_set_busy(df_select);			// ؑZ
#if (DF_NB_MEM == 1)
			if (nb_sector != 0)
				df_write_open(gl_ptr_mem>>9);
#endif
		}
#else
		// ߰ނ̍Ō
		Df_desel_all();						// ߰ޏ݊Jn
		df_set_busy(df_select);				// ؑZ
#if (DF_NB_MEM == 1)
		if (nb_sector != 0)
			df_write_open(gl_ptr_mem>>9);
#endif
#endif
	}
	while (nb_sector != 0);

	return OK;								// ݏI
}

#if( USB_HOST_FEATURE==ENABLE )
//!
//! @brief ̊֐͍œKAUSBνĐ킩DataFlashnb-sector~512޲Ă܂B
//!		   ް̗USBDataFlash
//!
//! :
//!   - ̊֐USBνē`ԂŎgp鎞ɂgpׂłB
//!   - ŏ̌Ăяodf_write_open()֐ĂяoɂĐsȂ΂Ȃ܂B
//!   - 12߰ޗeʂ̖񐔂Ȃ̂ŁAe޲Ăɑ΂߰ޏI𒲂ׂKv܂B
//!   - USB OUT PIPEɑIĂȂ΂Ȃ܂B
//!   - v튄荞݂邽߁A]Ɋ荞݂֎~܂B
//!   - nb_sector͏Ɂ1ŁA0ɂł܂B
//!
//! @warning code:??޲ (֐ޒ)
//!
//! @param	nb_sector	[IN]A
//!
//! @return	bit			ݐOK
//!/
bit df_host_write_sector (Uint16 nb_sector)
{
	Byte i;

	do
	{
		//# USB OUT FIFO8~64=512޲ď
		for (i = 8; i != 0; i--)
		{
			// USB IN߲߂ŎMIҋ@
			Host_unfreeze_pipe();
			while(Is_host_read_enabled()==FALSE);

			Disable_interrupt();			// S̊荞݋֎~

			// SPI݌:޲đoSPIF׸މ
			// Spi_write_data(Usb_read_byte()):(.) SPIF׸މ̍ŏIiK
			//								   (.) USBǂ޲Ă𑗏o
			//								   (.) SPIF׸މ̍ŏ̒iK
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_write_data(Usb_read_byte());
			Spi_ack_write();				// SPIF׸މ̍ŏIiK
			Host_ack_in_received();			// USB IN PIPEǂݍ

			Enable_interrupt();				// S̊荞ݍċ
		} // for (i = 8; i != 0; i--)

		gl_ptr_mem += 512;					//  ߲XV
		nb_sector--;						// v팸

		//# ߰ނ̍ŌȂ߰ޏ݊Jn
		//#
#if DF_PAGE_SIZE > 512
		// 1024޲ ߰ނ̍Ōォ
		if ((MSB2(gl_ptr_mem) & DF_PAGE_MASK) == 0x00)
		{
			Df_desel_all();					// ߰ޏ݊Jn
			df_set_busy(df_select);			// ؑZ
#if (DF_NB_MEM == 1)
			if (nb_sector != 0)
				df_write_open(gl_ptr_mem>>9);
#endif
		}
#else
		// ߰ނ̍Ō
		Df_desel_all();						// ߰ޏ݊Jn
		df_set_busy(df_select);				// ؑZ
#if (DF_NB_MEM == 1)
		if (nb_sector != 0)
			df_write_open(gl_ptr_mem>>9);
#endif
#endif
	}
	while (nb_sector != 0);

	return OK;								// ݏI
}

//!
//! @brief ̊֐͍œKADataFlashUSBνĐnb-sector~512޲Ă܂B
//!		   ް̗dataFlashUSB
//!
//! :
//!   - ̊֐USBνē`ԂŎgp鎞ɂgpׂłB
//!   - ŏ̌Ăяodf_read_open()֐ĂяoɂĐsȂ΂Ȃ܂B
//!   - USB IN PIPE͐ɑIĂȂ΂Ȃ܂B
//!   - USB݊ɏՕ͋󂫁A
//!   - 512߰ޗeʂ̖񐔂Ȃ̂ŁAe޲Ăɑ΂߰ނ̍Ō̌Kv܂B
//!   - v튄荞݂邽߁A]Ɋ荞݂͋֎~܂B
//!   - nb_sector͏Ɂ1ŁA0ɂł܂B
//!
//! @warning code:??޲ (֐ޒ)
//!
//! @param	nb_sector	ǂ[IN]A
//!
//! @return	bit			ǂݍݐOK
//!/
bit df_host_read_sector (Uint16 nb_sector)
{
	U8 i;
	do
	{
		for (i = 8; i != 0; i--)
		{
			Disable_interrupt();			// S̊荞݋֎~

			// 				 : ޲Ă𓾂邽߂ɉ޲Ă𑗏o
			// Spi_write_data(0) : ޲Ă𑗏o+SPIF׸މ̍ŏ̒iK
			// Spi_read_data()	 : ޲Ď擾+SPIF׸މ̍ŏIiK
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());
			Spi_write_data(0); Usb_write_byte(Spi_read_data());

			Enable_interrupt();				// S̊荞ݍċ

			//#
			//# USB IN FIFOeUSBνĂ֑o
			//#
			Host_send_out();				// USBνĂFIFO֑o
			Host_unfreeze_pipe();
			// IN FIFOɍĂя悤ɑMI܂őҋ@
			while(Is_host_out_sent()==FALSE);
			Host_ack_out_sent();
		}
		gl_ptr_mem += 512;					// S̱ڽ ߲is()
		nb_sector--;						// v팸
#if (DF_NB_MEM == 1)						// ߰ނ̍Ō?
#if (DF_PAGE_SIZE == 512)
		Df_desel_all();
		if (nb_sector != 0)
			df_read_open(gl_ptr_mem>>9);
#else
		if ((MSB2(gl_ptr_mem) & DF_PAGE_MASK) == 0x00)
		{
			Df_desel_all();
			if (nb_sector != 0)
				df_read_open(gl_ptr_mem>>9);
		}
#endif
#endif
	}
	while (nb_sector != 0);

	return OK;								// ǂݍݏI
}
#endif // USB_HOST_FEATURE==ENABLE

//! ̊֐1DataFlashǂłRAMɏՕɊi[܂B
//!
//! :
//!   - ŏ̌Ăяodf_read_open()֐ɂĐsȂ΂Ȃ܂B
//!
//! @param	*ram	RAMɏՕւ߲
//!
//! @return			ǂݍݐOK
//!
Bool df_read_sector_2_ram (U8 *ram)
{
	U16 i;
	for(i=0;i<512;i++)
	{
		Spi_write_data(0);
		*ram=Spi_read_data();
		ram++;
	}
	gl_ptr_mem += 512;						//  ߲XV
	return OK;
}

//! ̊֐RAMɏՕ1DataFlash܂B
//!
//! :
//!   - ŏ̌Ăяodf_write_open()֐ĂяoɂĐsȂ΂Ȃ܂B
//!
//! @param	*ram	RAMɏՕւ߲
//!
//! @return			ݐOK
//!
Bool df_write_sector_from_ram (U8 *ram)
{
	U16 i;
	for(i=0;i<512;i++)
	{
		Spi_write_data(*ram);
		ram++;
	}
	Spi_ack_write();						// SPIF׸މ̍ŏIiK
	gl_ptr_mem += 512;						//  ߲XV
	return OK;
}
